commit 5b57121efc959abe46a429728294b9083b75edaf
Author: Captain_Trojan <sejakm@students.zcu.cz>
Date:   Wed Apr 7 00:19:27 2021 +0200

    Re #8476 - Refactored the application; swagger is not used for code generation anymore, REST API is being implemented from scratch. Migration only, fixing tests.

diff --git a/app.py b/app.py
index 95f6c2a..92b1c07 100644
--- a/app.py
+++ b/app.py
@@ -1,5 +1,6 @@
 from flask import Flask
 import os
+from src.controllers.certificates_controller import CertController
 
 app = Flask(__name__)
 
@@ -9,6 +10,16 @@ def index():
     return 'Welcome to the X.509 management application homepage!'
 
 
+@app.route('/api/certificates', methods=["POST"])
+def create_certificate():
+    return CertController.create_certificate()
+
+
+@app.route('/api/certificates', methods=["GET"])
+def get_cert_list():
+    return CertController.get_certificate_list()
+
+
 if __name__ == '__main__':
     host = "0.0.0.0"
     port = 5000
@@ -20,5 +31,4 @@ if __name__ == '__main__':
     if "FLASK_PORT" in os.environ:
         host = os.environ["FLASK_PORT"]
 
-    app.run(host=host, port=port)
-
+    app.run(host=host, port=port)
\ No newline at end of file
diff --git a/src/controllers/certificates_controller.py b/src/controllers/certificates_controller.py
new file mode 100644
index 0000000..6081f30
--- /dev/null
+++ b/src/controllers/certificates_controller.py
@@ -0,0 +1,277 @@
+from datetime import datetime
+from itertools import chain
+from flask import request
+from src.dao.private_key_repository import PrivateKeyRepository
+from src.model.subject import Subject
+from src.services.certificate_service import CertificateService
+from src.dao.certificate_repository import CertificateRepository  # TODO not the Controller's responsibility. 1
+from src.services.cryptography import CryptographyService  # TODO not the Controller's responsibility. 2
+from sqlite3 import Connection  # TODO not the Controller's responsibility. 3
+from src.constants import DICT_USAGES, CA_ID, \
+    DATABASE_FILE_LOCATION, SSL_ID, SIGNATURE_ID, AUTHENTICATION_ID, \
+    DATETIME_FORMAT, ROOT_CA_ID, INTERMEDIATE_CA_ID, CERTIFICATE_ID  # TODO DATABASE_FILE - not the Controller's
+#  responsibility. 4
+from src.services.key_service import KeyService
+
+# _ = Connection("../" + DATABASE_FILE)                                 # TODO not the Controller's responsibility. 5
+# cursor = _.cursor()                                                   # TODO responsibility of the
+                                                                        #  CertificateRepository. It makes no sense to
+                                                                        #  supply a different cursor than precisely
+                                                                        #  the one corresponding to the connection.
+                                                                        #  The cursor can always be generated from the
+                                                                        #  connection instance.
+FILTERING = "filtering"
+ISSUER = "issuer"
+US = "usage"
+NOT_AFTER = "notAfter"
+NOT_BEFORE = "notBefore"
+COMMON_NAME = "CN"
+ID = "id"
+E_NO_ISSUER_FOUND = {"success": False,
+                           "data": "No certificate authority with such unique ID exists."}
+E_NO_CERTIFICATES_FOUND = {"success": False, "data": "No certificates found."}
+E_NOT_JSON_FORMAT = {"success": False, "data": "The request must be JSON-formatted."}
+E_CORRUPTED_DATABASE = {"success": False, "data": "Internal server error (corrupted database)."}
+E_GENERAL_ERROR = {"success": False, "data": "Internal server error (unknown origin)."}
+E_MISSING_PARAMETERS = {"success": False, "data": "Invalid request, missing parameters."}
+E_WRONG_PARAMETERS = {"success": False, "data": "Invalid request, wrong parameters."}
+USAGE = "usage"
+SUBJECT = "subject"
+VALIDITY_DAYS = "validityDays"
+CA = "CA"
+
+__ = CryptographyService()  # TODO not the Controller's responsibility. 6
+CERTIFICATE_SERVICE = CertificateService(__, CertificateRepository(None, None))
+# TODO open for discussion. Expected:
+#  CS = CertificateService.get_instance()
+#  or something like that.
+
+KEY_SERVICE = KeyService(__, PrivateKeyRepository(None, None))  # TODO as above
+
+
+class CertController:
+
+    @staticmethod
+    def setup():
+        """
+        SQLite3 thread issue hack.
+        :return:
+        """
+        _ = Connection(DATABASE_FILE_LOCATION.shortest_relative_path())
+        CERTIFICATE_SERVICE.certificate_repository.connection = _
+        CERTIFICATE_SERVICE.certificate_repository.cursor = _.cursor()
+        KEY_SERVICE.private_key_repository.connection = _
+        KEY_SERVICE.private_key_repository.cursor = _.cursor()
+
+    @staticmethod
+    def create_certificate():  # noqa: E501
+        """create new certificate
+
+        Create a new certificate based on given information # noqa: E501
+
+        :param body: Certificate data to be created
+        :type body: dict | bytes
+
+        :rtype: CreatedResponse
+        """
+        CertController.setup()  # TODO remove after issue fixed
+
+        key_map = {'CA': CA_ID, 'SSL': SSL_ID, 'digitalSignature': SIGNATURE_ID, 'authentication': AUTHENTICATION_ID}
+        required_keys = {SUBJECT, USAGE, VALIDITY_DAYS}
+
+        if request.is_json:
+            body = request.get_json()
+            if not all(k in body for k in required_keys):
+                return E_MISSING_PARAMETERS, 400
+
+            if not isinstance(body[VALIDITY_DAYS], int):
+                return E_WRONG_PARAMETERS, 400
+
+            subject = Subject.from_dict(body[SUBJECT])
+
+            if subject is None:
+                return E_WRONG_PARAMETERS, 400
+
+            usages_dict = DICT_USAGES.copy()
+
+            if not isinstance(body[USAGE], dict):
+                return E_WRONG_PARAMETERS, 400
+
+            for k, v in body[USAGE].items():
+                if k not in key_map:
+                    return E_WRONG_PARAMETERS, 400
+                usages_dict[key_map[k]] = v
+
+            key = KEY_SERVICE.create_new_key()  # TODO pass key
+
+            if CA not in body:
+                cert = CERTIFICATE_SERVICE.create_root_ca(
+                    key,
+                    subject,
+                    usages=usages_dict,
+                    days=body[VALIDITY_DAYS]
+                )
+            else:
+                issuer = CERTIFICATE_SERVICE.get_certificate(body[CA])
+
+                if issuer is None:
+                    return E_NO_ISSUER_FOUND, 400
+
+                issuer_key = KEY_SERVICE.get_key(issuer.private_key_id)
+
+                if issuer_key is None:
+                    return E_CORRUPTED_DATABASE, 500
+
+                f = CERTIFICATE_SERVICE.create_ca if CA_ID in usages_dict and usages_dict[CA_ID] else \
+                    CERTIFICATE_SERVICE.create_end_cert
+
+                cert = f(
+                    key,
+                    subject,
+                    issuer,
+                    issuer_key,
+                    usages=usages_dict,
+                    days=body[VALIDITY_DAYS]
+                )
+
+            if cert is not None:
+                return {"success": True,
+                        "data": cert.certificate_id}, 201
+            else:
+                return {"success": False,
+                        "data": "Internal error: The certificate could not have been created."}, 400
+        else:
+            return E_NOT_JSON_FORMAT, 400
+
+    @staticmethod
+    def get_certificate_by_id(id):  # noqa: E501
+        """get certificate by ID
+
+        Get certificate in PEM format by ID # noqa: E501
+
+        :param id: ID of a certificate to be queried
+        :type id: dict | bytes
+
+        :rtype: PemResponse
+        """
+        CertController.setup()  # TODO remove after issue fixed
+
+        if connexion.request.is_json:
+            id = IdParameter.from_dict(connexion.request.get_json())  # noqa: E501
+        return 'do some magic!'
+
+    @staticmethod
+    def get_certificate_details_by_id(id):  # noqa: E501
+        """get certificate&#x27;s details by ID
+
+        Get certificate details by ID # noqa: E501
+
+        :param id: ID of a certificate whose details are to be queried
+        :type id: dict | bytes
+
+        :rtype: CertificateResponse
+        """
+        CertController.setup()  # TODO remove after issue fixed
+
+        if connexion.request.is_json:
+            id = IdParameter.from_dict(connexion.request.get_json())  # noqa: E501
+        return 'do some magic!'
+
+    @staticmethod
+    def get_certificate_list():  # noqa: E501
+        """get list of certificates
+
+        Lists certificates based on provided filtering options # noqa: E501
+
+        :param filtering: Filter certificate type to be queried
+        :type filtering: dict | bytes
+
+        :rtype: CertificateListResponse
+        """
+        CertController.setup()  # TODO remove after issue fixed
+
+        key_map = {CA_ID: 'CA', SSL_ID: 'SSL', SIGNATURE_ID: 'digitalSignature', AUTHENTICATION_ID: 'authentication'}
+
+        targets = {ROOT_CA_ID, INTERMEDIATE_CA_ID, CERTIFICATE_ID}
+        if request.is_json:
+            data = request.get_json()
+            if FILTERING in data:
+                if isinstance(data[FILTERING], dict):
+                    if CA in data[FILTERING]:
+                        if isinstance(data[FILTERING][CA], bool):
+                            if data[FILTERING][CA]:
+                                targets.remove(CERTIFICATE_ID)
+                            else:
+                                targets.remove(ROOT_CA_ID)
+                                targets.remove(INTERMEDIATE_CA_ID)
+                        else:
+                            return E_WRONG_PARAMETERS, 400
+                else:
+                    return E_WRONG_PARAMETERS, 400
+
+        if len(targets) == 3:
+            certs = CERTIFICATE_SERVICE.get_certificates()
+        else:
+            certs = list(chain(CERTIFICATE_SERVICE.get_certificates(target) for target in targets))
+
+        if certs is None:
+            return E_GENERAL_ERROR, 500
+        elif len(certs) == 0:
+            return E_NO_CERTIFICATES_FOUND, 204
+        else:
+            ret = []
+            for c in certs:
+                c_issuer = CERTIFICATE_SERVICE.get_certificate(c.parent_id)
+                if c_issuer is None:
+                    return E_CORRUPTED_DATABASE, 500
+
+                ret.append(
+                    {
+                        ID: c.certificate_id,
+                        COMMON_NAME: c.common_name,
+                        NOT_BEFORE: datetime.strptime(c.valid_from, DATETIME_FORMAT).date(),
+                        NOT_AFTER: datetime.strptime(c.valid_to, DATETIME_FORMAT).date(),
+                        USAGE: {key_map[k]: v for k, v in c.usages.items()},
+                        ISSUER: {
+                            ID: c_issuer.certificate_id,
+                            COMMON_NAME: c_issuer.common_name
+                        }
+                    }
+                )
+            return {"success": True, "data": ret}
+
+
+
+    @staticmethod
+    def get_certificate_root_by_id(id):  # noqa: E501
+        """get certificate&#x27;s root of trust chain by ID
+
+        Get certificate&#x27;s root of trust chain in PEM format by ID # noqa: E501
+
+        :param id: ID of a child certificate whose root is to be queried
+        :type id: dict | bytes
+
+        :rtype: PemResponse
+        """
+        CertController.setup()  # TODO remove after issue fixed
+
+        if connexion.request.is_json:
+            id = IdParameter.from_dict(connexion.request.get_json())  # noqa: E501
+        return 'do some magic!'
+
+    @staticmethod
+    def get_certificate_trust_chain_by_id(id):  # noqa: E501
+        """get certificate&#x27;s trust chain by ID
+
+        Get certificate trust chain in PEM format by ID # noqa: E501
+
+        :param id: ID of a child certificate whose chain is to be queried
+        :type id: dict | bytes
+
+        :rtype: PemResponse
+        """
+        CertController.setup()  # TODO remove after issue fixed
+
+        if connexion.request.is_json:
+            id = IdParameter.from_dict(connexion.request.get_json())  # noqa: E501
+        return 'do some magic!'
diff --git a/src/model/subject.py b/src/model/subject.py
index 9e90077..e8bca57 100644
--- a/src/model/subject.py
+++ b/src/model/subject.py
@@ -1,4 +1,6 @@
 class Subject:
+    ATTR_MAP = {"C": "common_name", "ST": "state", "L": "locality", "CN": "common_name", "O": "organization",
+                "OU": "organization_unit", "emailAddress": "email_address"}
 
     def __init__(self, common_name=None, country=None, locality=None, state=None, organization=None,
                  organization_unit=None, email_address=None):
@@ -9,3 +11,17 @@ class Subject:
         self.organization = organization
         self.organization_unit = organization_unit
         self.email_address = email_address
+
+    @staticmethod
+    def from_dict(d):
+        if not isinstance(d, dict):
+            return None
+
+        s = Subject()
+        for k, v in Subject.ATTR_MAP.items():
+            if k in d:
+                if not isinstance(d[k], str):
+                    return None
+                s.__setattr__(v, d[k])
+
+        return s
diff --git a/src/utils/util.py b/src/utils/util.py
new file mode 100644
index 0000000..edb2251
--- /dev/null
+++ b/src/utils/util.py
@@ -0,0 +1,141 @@
+import datetime
+
+import six
+import typing
+
+
+def _deserialize(data, klass):
+    """Deserializes dict, list, str into an object.
+
+    :param data: dict, list or str.
+    :param klass: class literal, or string of class name.
+
+    :return: object.
+    """
+    if data is None:
+        return None
+
+    if klass in six.integer_types or klass in (float, str, bool):
+        return _deserialize_primitive(data, klass)
+    elif klass == object:
+        return _deserialize_object(data)
+    elif klass == datetime.date:
+        return deserialize_date(data)
+    elif klass == datetime.datetime:
+        return deserialize_datetime(data)
+    elif hasattr(klass, '__origin__'):
+        if klass.__origin__ == list:
+            return _deserialize_list(data, klass.__args__[0])
+        if klass.__origin__ == dict:
+            return _deserialize_dict(data, klass.__args__[1])
+    else:
+        return deserialize_model(data, klass)
+
+
+def _deserialize_primitive(data, klass):
+    """Deserializes to primitive type.
+
+    :param data: data to deserialize.
+    :param klass: class literal.
+
+    :return: int, long, float, str, bool.
+    :rtype: int | long | float | str | bool
+    """
+    try:
+        value = klass(data)
+    except UnicodeEncodeError:
+        value = six.u(data)
+    except TypeError:
+        value = data
+    return value
+
+
+def _deserialize_object(value):
+    """Return a original value.
+
+    :return: object.
+    """
+    return value
+
+
+def deserialize_date(string):
+    """Deserializes string to date.
+
+    :param string: str.
+    :type string: str
+    :return: date.
+    :rtype: date
+    """
+    try:
+        from dateutil.parser import parse
+        return parse(string).date()
+    except ImportError:
+        return string
+
+
+def deserialize_datetime(string):
+    """Deserializes string to datetime.
+
+    The string should be in iso8601 datetime format.
+
+    :param string: str.
+    :type string: str
+    :return: datetime.
+    :rtype: datetime
+    """
+    try:
+        from dateutil.parser import parse
+        return parse(string)
+    except ImportError:
+        return string
+
+
+def deserialize_model(data, klass):
+    """Deserializes list or dict to model.
+
+    :param data: dict, list.
+    :type data: dict | list
+    :param klass: class literal.
+    :return: model object.
+    """
+    instance = klass()
+
+    if not instance.swagger_types:
+        return data
+
+    for attr, attr_type in six.iteritems(instance.swagger_types):
+        if data is not None \
+                and instance.attribute_map[attr] in data \
+                and isinstance(data, (list, dict)):
+            value = data[instance.attribute_map[attr]]
+            setattr(instance, attr, _deserialize(value, attr_type))
+
+    return instance
+
+
+def _deserialize_list(data, boxed_type):
+    """Deserializes a list and its elements.
+
+    :param data: list to deserialize.
+    :type data: list
+    :param boxed_type: class literal.
+
+    :return: deserialized list.
+    :rtype: list
+    """
+    return [_deserialize(sub_data, boxed_type)
+            for sub_data in data]
+
+
+def _deserialize_dict(data, boxed_type):
+    """Deserializes a dict and its elements.
+
+    :param data: dict to deserialize.
+    :type data: dict
+    :param boxed_type: class literal.
+
+    :return: deserialized dict.
+    :rtype: dict
+    """
+    return {k: _deserialize(v, boxed_type)
+            for k, v in six.iteritems(data)}
diff --git a/tests/unit_tests/rest_api/certificates.py b/tests/unit_tests/rest_api/certificates.py
index 3564292..1565934 100644
--- a/tests/unit_tests/rest_api/certificates.py
+++ b/tests/unit_tests/rest_api/certificates.py
@@ -2,7 +2,8 @@ def test_import(server):
     assert 1 + 2 + 3 + 4 != -1 / 12
 
     ret = server.get("/")
-    assert ret.status_code == 404
+    assert ret.status_code == 200
+    assert str(ret.data, encoding='utf-8') == "Welcome to the X.509 management application homepage!"
 
 
 def test_root_ca(server):
@@ -53,10 +54,10 @@ def test_invalid_params_1(server):
 
     d = ret.json
 
-    assert "status" in d
-    assert d["status"] == 400
-    assert "detail" in d
-    assert d["detail"] == "'usage' is a required property"
+    assert "data" in d
+    assert d["data"] == "Invalid request, missing parameters."
+    assert "success" in d
+    assert not d["success"]
 
 
 def test_invalid_params_2(server):
@@ -83,10 +84,10 @@ def test_invalid_params_2(server):
 
     d = ret.json
 
-    assert "status" in d
-    assert d["status"] == 400
-    assert "detail" in d
-    assert d["detail"] == "'tak mesic treba plus minus' is not of type 'integer' - 'validityDays'"
+    assert "data" in d
+    assert d["data"] == "Invalid request, wrong parameters."
+    assert "success" in d
+    assert not d["success"]
 
 
 def test_invalid_params_3(server):
@@ -113,10 +114,10 @@ def test_invalid_params_3(server):
 
     d = ret.json
 
-    assert "status" in d
-    assert d["status"] == 400
-    assert "detail" in d
-    assert d["detail"] == "['Bosna', 'Herzegovina'] is not of type 'string' - 'subject.ST'"
+    assert "data" in d
+    assert d["data"] == "Invalid request, wrong parameters."
+    assert "success" in d
+    assert not d["success"]
 
 
 def test_root_inter_ca(server):
diff --git a/tests/unit_tests/rest_api/conftest.py b/tests/unit_tests/rest_api/conftest.py
index e7c9227..dc168d4 100644
--- a/tests/unit_tests/rest_api/conftest.py
+++ b/tests/unit_tests/rest_api/conftest.py
@@ -1,12 +1,11 @@
 import pytest
-from swagger_server.__main__ import app as flask_app, setup
+from app import app as flask_app
 from src.db.setup_database import setup_database
 
 
 @pytest.fixture(scope="session")
 def server():
     setup_database()
-    setup(flask_app)
-    flask_app.app.testing = True
-    with flask_app.app.test_client() as s:
+    flask_app.testing = True
+    with flask_app.test_client() as s:
         yield s
